 rm(list=ls())
 mulohi <- function(x) as.numeric(c(mean(x),quantile(x,c(1,39)/40)))
 cute <- function(zz,n){ z <- format(round(zz,n),nsmall=n); paste0(z[1]," (",z[2],", ",z[3],")") }
 tab_suffix <- "Tab_Shanghai_manuscript_11-22-2019"
 
######################################

setwd("/Users/nicolasmenzie/Google Drive/Harvard/Shanghai TB modelling/ShanghaiTB_6-22/3-Calibration")

########## LOAD DATA, OBJECTS AND FUNCTIONS ##########
  load("data_inputs_10-10-19.rData") # InitPopAgeSex,InitMig,InitPrDur,Birthst,PrRes,PrMigration,PrMiSex0,PrMiSex,BgMort,rrMort,mig_manuf_const
  Birthst <- Birthst[c(1:48,rep(48,10))]; BgMort <- BgMort[c(1:48,rep(48,10))]
  load("calib_inputs_8-26-19.rData") 
  load("prior_objects_11_21_2019.rData") # hyper_pars,hyper_pars_c,lPrior,idZ0,idZ1,idZ2,init_draws,untransform_P,P_init
  source("process_parameters_proj_V4.r")
  source("model_function_V8scen.r")
  source("calibration_functions_V1.r")
  load("hyper_pars_c2a_9-16-2019.rData") # hyper_pars_c2
  load("fit3_9-17-2019.rData") # fit3,y4f,file
  load("hyper_pars_c2b_9-16-2019.rData") # hyper_pars_c2b
  hyper_pars_c3b <- hyper_pars_c2b[-grep("spln",hyper_pars_c2b$par_name),]
  load("addn_parameter_draws_10_31_2019.rData") # samp_addn_pars,hyper_pars_addn
  load("imis_result_Shanghai_1_1_9-16-2019.rData") # imis_result
  set.seed(3); jumble <- sample.int(1000)
  samp <- imis_result$resample[jumble,]

  ###
  
  P0 <- P_init
  
  ## Function to run model
  func_model_proj <- function(pars,addn_pars,ids,P0,imm_scen,bur_scen,sc_i,yrs_extra){ 
      #  ~~~~~ process parameters ~~~~~
      P <- P0
      P[hyper_pars$calib==1][ids] <- untransform_P(pars,ids)
      O <- make_obj_for_sim(P,imm_scen,bur_scen,sc_i)
      Int1 <- Int2 <- Int3 <- Int4 <- Int5 <- 0
      if(sc_i%in%c(1,2,7  )){  Int1 <- 1  }  # active TB tx in elderly
      if(sc_i%in%c(2,7    )){  Int2 <- 1  }  # TLTBI in elderly
      if(sc_i%in%c(3,4,6,7)){  Int3 <- 1  }  # entry screening and Tb TX in new migrants
      if(sc_i%in%c(4,6,7  )){  Int4 <- 1  }  # entry screening and TLTBI in new migrants
      if(sc_i%in%c(5,6,7  )){  Int5 <- 1  }  # yearly screening and TB TX for migrants
      
      incr_sens   <- addn_pars[1] # Int1
      p_cure_ipt  <- addn_pars[2]*addn_pars[3]*addn_pars[4]*addn_pars[5] # Int2
      p_tx_tb_scr <- addn_pars[6]*addn_pars[7] # Int3
      rel_sens_e  <- addn_pars[8]
      #  ~~~~~ run model ~~~~~
      Out          <- cModel(nYrs       = 18+yrs_extra,        nRes       = length(ResNam), 
                             InitPopAgeSex =InitPopAgeSex,     InitMig    = InitMig,       InitPrDur  = InitPrDur,
                             Birthst    = Birthst,             PrRes      = PrRes,         BgMort     = BgMort,
                             rrMort     = rrMort,              p_Male     = O$p_Male,      ResMove    = O$ResMove,
                             emig_rate  = O$emig_rate,         Imm        = O$Imm,         PrImm      = O$PrImm,
                             muTb       = O$muTb,              rrmuTb_smrn= O$rrmuTb_smrn, rrmuTb_trt = O$rrmuTb_trt,
                             rrmuTb_age = O$rrmuTb_age,        effCR      = O$effCR,       rrFemCR    = O$rrFemCR,
                             rrMigCR    = O$rrMigCR,           rrInfect   = O$rrInfect,    alpha      = O$alpha,
                             pfast_ag   = O$pfast_ag,          rrpfastPI  = O$rrpfastPI,   rRecov     = O$rRecov,
                             rSlfCur    = O$rSlfCur,           rfast      = O$rfast,       rslow_ag   = O$rslow_ag,
                             rslow_agF  = O$rslow_agF,        rrImmActive = O$rrImmActive, Txeff      = O$Txeff,
                             rProgress  = O$rProgress,         pSmrP      = O$pSmrP,       rSmrConv   = O$rSmrConv,
                             rDiag      = O$rDiag,             dDetect    = O$dDetect,     rrSenst    = O$rrSenst,
                             rrDiagMi   = O$rrDiagMi,          rComplete  = O$rComplete,   rDefault   = O$rDefault,
                             pfast_agF  = O$pfast_agF,         cont_mat0  = O$cont_mat0,   scale_up   = O$scale_up,
                             decl_entr_tb = O$decl_entr_tb,    incr_sens  = incr_sens,     p_cure_ipt = p_cure_ipt,    
                             p_tx_tb_scr = p_tx_tb_scr,        mig_manuf_const = mig_manuf_const,rel_sens_e = rel_sens_e,
                             Int1       = Int1,                Int2       = Int2,          Int3       = Int3,
                             Int4       = Int4,                Int5       = Int5
                             )$Out
      
      colnames(Out) <- ResNam
      Out2 <- list( MortRes    = Out[,grep("MortRes_",ResNam)],
                    MortMig    = Out[,grep("MortMig_",ResNam)],
                    TotRes     = Out[,grep("TotRes_",ResNam)],
                    TotResMale = Out[,grep("TotResMale_",ResNam)],
                    TotResFemale = Out[,grep("TotResFemale_",ResNam)],
                    TotMig = Out[,grep("TotMig_",ResNam)],
                    TotMigMale = Out[,grep("TotMigMale_",ResNam)],
                    TotMigFemale = Out[,grep("TotMigFemale_",ResNam)],
                    TotIncidResMale = Out[,grep("TotIncidResMale_",ResNam)],
                    TotIncidResFemale = Out[,grep("TotIncidResFemale_",ResNam)],
                    TotIncidMigMale = Out[,grep("TotIncidMigMale_",ResNam)],
                    TotIncidMigFemale = Out[,grep("TotIncidMigFemale_",ResNam)],
                    Case = Out[,grep("Case_",ResNam)],
                    Fatality = Out[,grep("Fatality_",ResNam)],
                    TotNotifResMale = Out[,grep("TotNotifResMale_",ResNam)],
                    TotNotifResFemale = Out[,grep("TotNotifResFemale_",ResNam)],
                    TotNotifMigMale = Out[,grep("TotNotifMigMale_",ResNam)],
                    TotNotifMigFemale = Out[,grep("TotNotifMigFemale_",ResNam)],
                    DurImm = Out[,grep("DurImm_",ResNam)],
                    Mortl = Out[,grep("Mortl",ResNam)],
                    NotifRes = Out[,grep("NotifRes",ResNam)],
                    NotifMig = Out[,grep("NotifMig",ResNam)],
                    PInfMigIfMig = Out[,grep("PInfMigIfMig",ResNam)],
                    PInfMigIfRes = Out[,grep("PInfMigIfRes",ResNam)],
                    RtMigFromRes = Out[,grep("RtMigFromRes_",ResNam)],
                    RtMigFromMig = Out[,grep("RtMigFromMig_",ResNam)],
                    RtResFromRes = Out[,grep("RtResFromRes_",ResNam)],
                    RtResFromMig = Out[,grep("RtResFromMig_",ResNam)],
                    TotTbDthRes = Out[,grep("TotTbDthResMale_",ResNam)]+Out[,grep("TotTbDthResFemale_",ResNam)],
                    TotTbDthMig = Out[,grep("TotTbDthMigMale_",ResNam)]+Out[,grep("TotTbDthMigFemale_",ResNam)],
                    TotTbYllRes = (Out[,grep("TotTbDthResMale_",ResNam)]+Out[,grep("TotTbDthResFemale_",ResNam)])*matrix(rowMeans(le),18+yrs_extra,20,byrow=T),
                    TotTbYllMig = (Out[,grep("TotTbDthMigMale_",ResNam)]+Out[,grep("TotTbDthMigFemale_",ResNam)])*matrix(rowMeans(le),18+yrs_extra,20,byrow=T),
                    TotTbNltRes = Out[,grep("TotTbNltResMale_",ResNam)]+Out[,grep("TotTbNltResFemale_",ResNam)],
                    TotTbNltMig = Out[,grep("TotTbNltMigMale_",ResNam)]+Out[,grep("TotTbNltMigFemale_",ResNam)],
                    TotTbFoiRes = Out[,grep("TotTbFoiResMale_",ResNam)]+Out[,grep("TotTbFoiResFemale_",ResNam)],
                    TotTbFoiMig = Out[,grep("TotTbFoiMigMale_",ResNam)]+Out[,grep("TotTbFoiMigFemale_",ResNam)],
                    RtIncidRes  = Out[,grep("RtIncidResMale_",ResNam)]+Out[,grep("RtIncidResFemale_",ResNam)],
                    RtIncidMig  = Out[,grep("RtIncidMigMale_",ResNam)]+Out[,grep("RtIncidMigFemale_",ResNam)],
                    ImpCaseRes  = Out[,grep("ImpCaseResMale_",ResNam)]+Out[,grep("ImpCaseResFemale_",ResNam)],
                    ImpCaseMig  = Out[,grep("ImpCaseMigMale_",ResNam)]+Out[,grep("ImpCaseMigFemale_",ResNam)]
                    )
    return(Out2)  
  }
  scen_sim0Z <- func_model_proj(pars=samp[1,], addn_pars= samp_addn_pars[1,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = 1,bur_scen = 1,sc_i = 0,yrs_extra = 17+15)
  scen_sim02 <- func_model_proj(pars=samp[3,], addn_pars= samp_addn_pars[3,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = 1,bur_scen = 1,sc_i = 0,yrs_extra = 17+15)

  scen_sim <- array(NA,dim=c(35,20,36,1000,8))
  dimnames(scen_sim)[[1]] <- 2000:2034
  dimnames(scen_sim)[[2]] <- paste0("age",1:20)
  dimnames(scen_sim)[[3]] <- names(scen_sim0Z)[c(1:18,23:40)]
  dimnames(scen_sim)[[5]] <- paste0("scen",0:7)
  
  P0 <- P_init

#################################################
######## SA - high immig -  #####################
#################################################
  
  im_j <- 2; br_j <- 1; ye_j <- 17
  scen_sim0 <- scen_sim1 <- scen_sim2 <- scen_sim3 <- scen_sim4 <- scen_sim5 <- scen_sim6 <- scen_sim7 <- list()
  for(i in 1:1000){
    scen_sim0[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 0,yrs_extra = ye_j)
    scen_sim1[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 1,yrs_extra = ye_j)
    scen_sim2[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 2,yrs_extra = ye_j)
    scen_sim3[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 3,yrs_extra = ye_j)
    scen_sim4[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 4,yrs_extra = ye_j)
    scen_sim5[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 5,yrs_extra = ye_j)
    scen_sim6[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 6,yrs_extra = ye_j)
    scen_sim7[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 7,yrs_extra = ye_j)
    cat('\r',i,"     "); flush.console() }
  
    scen_sim[,,,,] <- NA

    for(i in 1:1000){  for(j in 1:36){
      scen_sim[,,j,i,1] <- scen_sim0[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,2] <- scen_sim1[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,3] <- scen_sim2[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,4] <- scen_sim3[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,5] <- scen_sim4[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,6] <- scen_sim5[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,7] <- scen_sim6[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,8] <- scen_sim7[[i]][[c(1:18,23:40)[j]]]  }  }
  
    # cumulative outcomes (pct)
    rownm <- paste0(rep(paste0("scenario",2:7),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- paste0(rep(c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB"),each=3),rep(c("_mn","_lo","_hi"),5))
    tab4 <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4) <- c("indicator",colnm)
    tab4$indicator <- rownm
    
    # transmission
    for(i in 1:6) tab4[0+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1],4,sum))
    # infection
    for(i in 1:6) tab4[0+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1],4,sum))
    # cases
    for(i in 1:6) tab4[0+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1],4,sum))
    for(i in 1:6) tab4[6+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    for(i in 1:6) tab4[12+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    # deaths
    for(i in 1:6) tab4[0+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1],4,sum))
    # YLL
    for(i in 1:6) tab4[0+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1],4,sum))
    
    rownm <- paste0(rep(paste0("scenario",2:7,"_2035"),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB")
    tab4b <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4b) <- c("indicator",colnm)
    tab4b$indicator <- rownm
    
    for(i in 1:nrow(tab4))  tab4b[i,2] <- cute(tab4[i,2:4],1)
    for(i in 1:nrow(tab4))  tab4b[i,3] <- cute(tab4[i,2:4+3],1)
    for(i in 1:nrow(tab4))  tab4b[i,4] <- cute(tab4[i,2:4+6],1)
    for(i in 1:nrow(tab4))  tab4b[i,5] <- cute(tab4[i,2:4+9],1)
    for(i in 1:nrow(tab4))  tab4b[i,6] <- cute(tab4[i,2:4+12],1)
    
    write.csv(tab4,file=paste0(tab_suffix, "_pct_cum_outcomes_immig_lo.csv"),row.names=F)
    write.csv(tab4b,file=paste0(tab_suffix, "_pct_cum_outcomes_formatted_immig_lo.csv"),row.names=F)
    
#################################################
######## SA - high immig  #######################
#################################################
    
    im_j <- 3; br_j <- 1; ye_j <- 17
    scen_sim0 <- scen_sim1 <- scen_sim2 <- scen_sim3 <- scen_sim4 <- scen_sim5 <- scen_sim6 <- scen_sim7 <- list()
    for(i in 1:1000){
      scen_sim0[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 0,yrs_extra = ye_j)
      scen_sim1[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 1,yrs_extra = ye_j)
      scen_sim2[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 2,yrs_extra = ye_j)
      scen_sim3[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 3,yrs_extra = ye_j)
      scen_sim4[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 4,yrs_extra = ye_j)
      scen_sim5[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 5,yrs_extra = ye_j)
      scen_sim6[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 6,yrs_extra = ye_j)
      scen_sim7[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 7,yrs_extra = ye_j)
      cat('\r',i,"     "); flush.console() }
    
    scen_sim[,,,,] <- NA
    
    for(i in 1:1000){  for(j in 1:36){
      scen_sim[,,j,i,1] <- scen_sim0[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,2] <- scen_sim1[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,3] <- scen_sim2[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,4] <- scen_sim3[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,5] <- scen_sim4[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,6] <- scen_sim5[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,7] <- scen_sim6[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,8] <- scen_sim7[[i]][[c(1:18,23:40)[j]]]  }  }
    
    # cumulative outcomes (pct)
    rownm <- paste0(rep(paste0("scenario",2:7),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- paste0(rep(c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB"),each=3),rep(c("_mn","_lo","_hi"),5))
    tab4 <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4) <- c("indicator",colnm)
    tab4$indicator <- rownm
    
    # transmission
    for(i in 1:6) tab4[0+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1],4,sum))
    # infection
    for(i in 1:6) tab4[0+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1],4,sum))
    # cases
    for(i in 1:6) tab4[0+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1],4,sum))
    for(i in 1:6) tab4[6+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    for(i in 1:6) tab4[12+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    # deaths
    for(i in 1:6) tab4[0+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1],4,sum))
    # YLL
    for(i in 1:6) tab4[0+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1],4,sum))
    
    rownm <- paste0(rep(paste0("scenario",2:7,"_2035"),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB")
    tab4b <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4b) <- c("indicator",colnm)
    tab4b$indicator <- rownm
    
    for(i in 1:nrow(tab4))  tab4b[i,2] <- cute(tab4[i,2:4],1)
    for(i in 1:nrow(tab4))  tab4b[i,3] <- cute(tab4[i,2:4+3],1)
    for(i in 1:nrow(tab4))  tab4b[i,4] <- cute(tab4[i,2:4+6],1)
    for(i in 1:nrow(tab4))  tab4b[i,5] <- cute(tab4[i,2:4+9],1)
    for(i in 1:nrow(tab4))  tab4b[i,6] <- cute(tab4[i,2:4+12],1)
    
    write.csv(tab4,file=paste0(tab_suffix, "_pct_cum_outcomes_immig_hi.csv"),row.names=F)
    write.csv(tab4b,file=paste0(tab_suffix, "_pct_cum_outcomes_formatted_immig_hi.csv"),row.names=F)

    #################################################
    ######## SA - low  burden decline immig  #######################
    #################################################
    
    im_j <- 1; br_j <- 2; ye_j <- 17
    scen_sim0 <- scen_sim1 <- scen_sim2 <- scen_sim3 <- scen_sim4 <- scen_sim5 <- scen_sim6 <- scen_sim7 <- list()
    for(i in 1:1000){
      scen_sim0[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 0,yrs_extra = ye_j)
      scen_sim1[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 1,yrs_extra = ye_j)
      scen_sim2[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 2,yrs_extra = ye_j)
      scen_sim3[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 3,yrs_extra = ye_j)
      scen_sim4[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 4,yrs_extra = ye_j)
      scen_sim5[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 5,yrs_extra = ye_j)
      scen_sim6[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 6,yrs_extra = ye_j)
      scen_sim7[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 7,yrs_extra = ye_j)
      cat('\r',i,"     "); flush.console() }
    
    scen_sim[,,,,] <- NA
    
    for(i in 1:1000){  for(j in 1:36){
      scen_sim[,,j,i,1] <- scen_sim0[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,2] <- scen_sim1[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,3] <- scen_sim2[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,4] <- scen_sim3[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,5] <- scen_sim4[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,6] <- scen_sim5[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,7] <- scen_sim6[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,8] <- scen_sim7[[i]][[c(1:18,23:40)[j]]]  }  }
    
    # cumulative outcomes (pct)
    rownm <- paste0(rep(paste0("scenario",2:7),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- paste0(rep(c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB"),each=3),rep(c("_mn","_lo","_hi"),5))
    tab4 <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4) <- c("indicator",colnm)
    tab4$indicator <- rownm
    
    # transmission
    for(i in 1:6) tab4[0+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1],4,sum))
    # infection
    for(i in 1:6) tab4[0+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1],4,sum))
    # cases
    for(i in 1:6) tab4[0+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1],4,sum))
    for(i in 1:6) tab4[6+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    for(i in 1:6) tab4[12+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    # deaths
    for(i in 1:6) tab4[0+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1],4,sum))
    # YLL
    for(i in 1:6) tab4[0+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1],4,sum))
    
    rownm <- paste0(rep(paste0("scenario",2:7,"_2035"),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB")
    tab4b <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4b) <- c("indicator",colnm)
    tab4b$indicator <- rownm
    
    for(i in 1:nrow(tab4))  tab4b[i,2] <- cute(tab4[i,2:4],1)
    for(i in 1:nrow(tab4))  tab4b[i,3] <- cute(tab4[i,2:4+3],1)
    for(i in 1:nrow(tab4))  tab4b[i,4] <- cute(tab4[i,2:4+6],1)
    for(i in 1:nrow(tab4))  tab4b[i,5] <- cute(tab4[i,2:4+9],1)
    for(i in 1:nrow(tab4))  tab4b[i,6] <- cute(tab4[i,2:4+12],1)
    
    write.csv(tab4,file=paste0(tab_suffix, "_pct_cum_outcomes_burden_tb_decline_lo.csv"),row.names=F)
    write.csv(tab4b,file=paste0(tab_suffix, "_pct_cum_outcomes_formatted_tb_decline_lo.csv"),row.names=F)

    #################################################
    ######## SA - high  burden decline immig  #######################
    #################################################
    
    im_j <- 1; br_j <- 3; ye_j <- 17
    scen_sim0 <- scen_sim1 <- scen_sim2 <- scen_sim3 <- scen_sim4 <- scen_sim5 <- scen_sim6 <- scen_sim7 <- list()
    for(i in 1:1000){
      scen_sim0[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 0,yrs_extra = ye_j)
      scen_sim1[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 1,yrs_extra = ye_j)
      scen_sim2[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 2,yrs_extra = ye_j)
      scen_sim3[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 3,yrs_extra = ye_j)
      scen_sim4[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 4,yrs_extra = ye_j)
      scen_sim5[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 5,yrs_extra = ye_j)
      scen_sim6[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 6,yrs_extra = ye_j)
      scen_sim7[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 7,yrs_extra = ye_j)
      cat('\r',i,"     "); flush.console() }
    
    scen_sim[,,,,] <- NA
    
    for(i in 1:1000){  for(j in 1:36){
      scen_sim[,,j,i,1] <- scen_sim0[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,2] <- scen_sim1[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,3] <- scen_sim2[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,4] <- scen_sim3[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,5] <- scen_sim4[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,6] <- scen_sim5[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,7] <- scen_sim6[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,8] <- scen_sim7[[i]][[c(1:18,23:40)[j]]]  }  }
    
    # cumulative outcomes (pct)
    rownm <- paste0(rep(paste0("scenario",2:7),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- paste0(rep(c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB"),each=3),rep(c("_mn","_lo","_hi"),5))
    tab4 <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4) <- c("indicator",colnm)
    tab4$indicator <- rownm
    
    # transmission
    for(i in 1:6) tab4[0+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbFoiMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbFoiMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbFoiRes","TotTbFoiMig"),,1],4,sum))
    # infection
    for(i in 1:6) tab4[0+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbNltMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbNltMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbNltRes","TotTbNltMig"),,1],4,sum))
    # cases
    for(i in 1:6) tab4[0+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1],4,sum))
    for(i in 1:6) tab4[6+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    for(i in 1:6) tab4[12+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    # deaths
    for(i in 1:6) tab4[0+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbDthMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbDthMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbDthRes","TotTbDthMig"),,1],4,sum))
    # YLL
    for(i in 1:6) tab4[0+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllRes",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,"TotTbYllMig",,1+i],3,sum)/apply(scen_sim[20:35,,"TotTbYllMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1+i],4,sum)/apply(scen_sim[20:35,,c("TotTbYllRes","TotTbYllMig"),,1],4,sum))
    
    rownm <- paste0(rep(paste0("scenario",2:7,"_2035"),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB")
    tab4b <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4b) <- c("indicator",colnm)
    tab4b$indicator <- rownm
    
    for(i in 1:nrow(tab4))  tab4b[i,2] <- cute(tab4[i,2:4],1)
    for(i in 1:nrow(tab4))  tab4b[i,3] <- cute(tab4[i,2:4+3],1)
    for(i in 1:nrow(tab4))  tab4b[i,4] <- cute(tab4[i,2:4+6],1)
    for(i in 1:nrow(tab4))  tab4b[i,5] <- cute(tab4[i,2:4+9],1)
    for(i in 1:nrow(tab4))  tab4b[i,6] <- cute(tab4[i,2:4+12],1)
    
    write.csv(tab4,file=paste0(tab_suffix, "_pct_cum_outcomes_burden_tb_decline_hi.csv"),row.names=F)
    write.csv(tab4b,file=paste0(tab_suffix, "_pct_cum_outcomes_formatted_tb_decline_hi.csv"),row.names=F)

    #################################################
    ######## SA - long time horizon  #######################
    #################################################
    
    im_j <- 1; br_j <- 1; ye_j <- 17+15
    scen_sim0 <- scen_sim1 <- scen_sim2 <- scen_sim3 <- scen_sim4 <- scen_sim5 <- scen_sim6 <- scen_sim7 <- list()
    for(i in 1:1000){
      scen_sim0[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 0,yrs_extra = ye_j)
      scen_sim1[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 1,yrs_extra = ye_j)
      scen_sim2[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 2,yrs_extra = ye_j)
      scen_sim3[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 3,yrs_extra = ye_j)
      scen_sim4[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 4,yrs_extra = ye_j)
      scen_sim5[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 5,yrs_extra = ye_j)
      scen_sim6[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 6,yrs_extra = ye_j)
      scen_sim7[[i]] <- func_model_proj(pars=samp[i,], addn_pars= samp_addn_pars[i,], ids=which(hyper_pars_c$calib==1), P0=P_init,imm_scen = im_j,bur_scen = br_j,sc_i = 7,yrs_extra = ye_j)
      cat('\r',i,"     "); flush.console() }
    
    scen_sim <- array(NA,dim=c(35+15,20,36,1000,8))
    dimnames(scen_sim)[[1]] <- 2000:2049
    dimnames(scen_sim)[[2]] <- paste0("age",1:20)
    dimnames(scen_sim)[[3]] <- names(scen_sim0[[1]])[c(1:18,23:40)]
    dimnames(scen_sim)[[5]] <- paste0("scen",0:7)
    
    for(i in 1:1000){  for(j in 1:36){
      scen_sim[,,j,i,1] <- scen_sim0[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,2] <- scen_sim1[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,3] <- scen_sim2[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,4] <- scen_sim3[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,5] <- scen_sim4[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,6] <- scen_sim5[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,7] <- scen_sim6[[i]][[c(1:18,23:40)[j]]]
      scen_sim[,,j,i,8] <- scen_sim7[[i]][[c(1:18,23:40)[j]]]  }  }
    
    # cumulative outcomes (pct)
    rownm <- paste0(rep(paste0("scenario",2:7),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- paste0(rep(c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB"),each=3),rep(c("_mn","_lo","_hi"),5))
    tab4 <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4) <- c("indicator",colnm)
    tab4$indicator <- rownm
    

    # transmission
    for(i in 1:6) tab4[0+i,2:4] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbFoiRes",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbFoiRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbFoiMig",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbFoiMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotTbFoiRes","TotTbFoiMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotTbFoiRes","TotTbFoiMig"),,1],4,sum))
    # infection
    for(i in 1:6) tab4[0+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbNltRes",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbNltRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbNltMig",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbNltMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+3] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotTbNltRes","TotTbNltMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotTbNltRes","TotTbNltMig"),,1],4,sum))
    # cases
    for(i in 1:6) tab4[0+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes"),,1],4,sum))
    for(i in 1:6) tab4[6+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    for(i in 1:6) tab4[12+i,2:4+6] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotIncidResMale","TotIncidResFemale","ImpCaseRes","TotIncidMigMale","TotIncidMigFemale","ImpCaseMig"),,1],4,sum))
    # deaths
    for(i in 1:6) tab4[0+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbDthRes",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbDthRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbDthMig",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbDthMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+9] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotTbDthRes","TotTbDthMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotTbDthRes","TotTbDthMig"),,1],4,sum))
    # YLL
    for(i in 1:6) tab4[0+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbYllRes",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbYllRes",,1],3,sum))
    for(i in 1:6) tab4[6+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:48,,"TotTbYllMig",,1+i],3,sum)/apply(scen_sim[20:48,,"TotTbYllMig",,1],3,sum))
    for(i in 1:6) tab4[12+i,2:4+12] <- mulohi(100-100*apply(scen_sim[20:48,,c("TotTbYllRes","TotTbYllMig"),,1+i],4,sum)/apply(scen_sim[20:48,,c("TotTbYllRes","TotTbYllMig"),,1],4,sum))
    
    rownm <- paste0(rep(paste0("scenario",2:7,"_2035"),3),rep(c("_resident","_migrant","_all"),each=6))
    colnm <- c("Transm_events","Mtb_infections","New_TB_cases","TB_deaths","YLL_to_TB")
    tab4b <- as.data.frame(matrix(NA,length(rownm),length(colnm)+1))
    colnames(tab4b) <- c("indicator",colnm)
    tab4b$indicator <- rownm
    
    for(i in 1:nrow(tab4))  tab4b[i,2] <- cute(tab4[i,2:4],1)
    for(i in 1:nrow(tab4))  tab4b[i,3] <- cute(tab4[i,2:4+3],1)
    for(i in 1:nrow(tab4))  tab4b[i,4] <- cute(tab4[i,2:4+6],1)
    for(i in 1:nrow(tab4))  tab4b[i,5] <- cute(tab4[i,2:4+9],1)
    for(i in 1:nrow(tab4))  tab4b[i,6] <- cute(tab4[i,2:4+12],1)
    
    write.csv(tab4,file=paste0(tab_suffix, "_pct_cum_outcomes_burden_long_time_horizon.csv"),row.names=F)
    write.csv(tab4b,file=paste0(tab_suffix, "_pct_cum_outcomes_formatted_long_time_horizon.csv"),row.names=F)
    #######
    
    
    
    